// Пример для одного светодиодного индикатора:                                         //
#include <Wire.h>                                                                      // Подключаем библиотеку Wire. Для работы с Arduino/Piranha, эту библиотеку можно не подключать.
#include <iarduino_Metro.h>                                                            // Подключаем библиотеку.
                                                                                       //
uint8_t sum;                                                                           // Объявляем  переменную для хранения количества найденных модулей Metro.
int     i=7;                                                                           // Определяем переменную для хранения яркости дисплея.
bool    f=true;                                                                        // Определяем флаг указывающий на увеличение яркости дисплея.
                                                                                       //
void setup(){                                                                          //
//  Определяем все модули на шине I2C и сохраняем их количество в переменную sum:      //
    sum=iarduino_Metro_Start();                                                        // В качестве аргумента функции iarduino_Metro_Start() можно указать номер адресного вывода (если вывод не указан, то будет использован D12).
//  Теперь нам доступен массив Metro содержащий sum элементов для управления модулями. // Metro[0] управляет ближайшим к Arduino модулем, Metro[1] управляет следующим модулем и т.д до последнего модуля Metro[sum-1].
                                                                                       //
//  Проверяем наличие модулей Metro на шине I2C:                                       //
    while(sum==0){;}                                                                   // Если модули Metro не обнаружены, то входим в бесконечный цикл while, тогда цикл loop выполняться не будет.
    while(Metro[0].model!=MOD_8X8){;}                                                  // Если ближайший к Arduino модуль Metro не является светодиодным индикатором, то так же входим в бесконечный цикл while.
                                                                                       //
    delay(100);                                                                        //
                                                                                       //
//  Включаем дисплей:                                                                  //
    Metro[0].on();                                                                     // Если функция on() вызвана без параметров, то весь дисплей будет залит.
}                                                                                      //
                                                                                       //
void loop(){                                                                           //
//  Применяем яркость дисплея:                                                         //
    Metro[0].on(i);                                                                    // Если функция on() вызвана с параметром от 0 до 10, то она установит яркость без изменения изображения дисплея.
    delay(500);                                                                        // Ждём пол секунды.
//  Изменяем значение яркости:                                                         //
    if(f){ i++; if(i>10){i=10; f=false;} }                                             // Увеличиваем значение яркости.
    else { i--; if(i<0 ){i=0;  f=true; } }                                             // Уменьшаем   значение яркости.
}                                                                                      //