// Пример для одного светодиодного индикатора:                                         //
#include <Wire.h>                                                                      // Подключаем библиотеку Wire. Для работы с Arduino/Piranha, эту библиотеку можно не подключать.
#include <iarduino_Metro.h>                                                            // Подключаем библиотеку.
                                                                                       //
uint8_t sum;                                                                           // Объявляем переменную для хранения количества найденных модулей Metro.
uint8_t image[8];                                                                      // Объявляем массив для вывода изображения. Массив имеет размер 8 байт (это строки), а в каждом байте по 8 бит (это столбцы).
                                                                                       //
void setup(){                                                                          //
//  Определяем все модули на шине I2C и сохраняем их количество в переменную sum:      //
    sum=iarduino_Metro_Start();                                                        // В качестве аргумента функции iarduino_Metro_Start() можно указать номер адресного вывода (если вывод не указан, то будет использован D12).
//  Теперь нам доступен массив Metro содержащий sum элементов для управления модулями. // Metro[0] управляет ближайшим к Arduino модулем, Metro[1] управляет следующим модулем и т.д до последнего модуля Metro[sum-1].
                                                                                       //
//  Проверяем наличие модулей Metro на шине I2C:                                       //
    while(sum==0){;}                                                                   // Если модули Metro не обнаружены, то входим в бесконечный цикл while, тогда цикл loop выполняться не будет.
    while(Metro[0].model!=MOD_8X8){;}                                                  // Если ближайший к Arduino модуль Metro не является светодиодным индикатором, то так же входим в бесконечный цикл while.
                                                                                       //
//  Создаём изображение (смайлик):                                                     //
    image[0] = 0b00111100;                                                             // Верхняя строка
    image[1] = 0b01000010;                                                             //
    image[2] = 0b10100101;                                                             //
    image[3] = 0b10000001;                                                             //
    image[4] = 0b10100101;                                                             //
    image[5] = 0b10011001;                                                             //
    image[6] = 0b01000010;                                                             //
    image[7] = 0b00111100;                                                             // Нижняя строка
                                                                                       //
    delay(100);                                                                        //
                                                                                       //
}                                                                                      //
                                                                                       //
void loop(){                                                                           //
//  Включаем дисплей:                                                                  //
    Metro[0].on(X8_EMPTY_RIPPLES);                                                     // В качестве параметра включения указываем функцию появления рябью из пустого фона.
    delay(2000);                                                                       // Ждём 2 секунды.
//  Выводим изображение на дисплей:                                                    //
    Metro[0].on(image, X8_FILLED_RIPPLES);                                             // Выводим на дисплей изображение массива image с функцией появления рябью из закрашенного фона.
    delay(5000);                                                                       // Ждём 5 секунд.
//  Выключаем дисплей:                                                                 //
    Metro[0].off(X8_EMPTY_RIPPLES);                                                    // В качестве параметра выключения указываем функцию исчезания рябью в пустой фон.
    delay(2000);                                                                       // Ждём 2 секунды.
}                                                                                      //
                                                                                       //
//  X8_EMPTY_RIPPLES                                                                   // анимация ряби        на пустом      фоне (появление из пустого      фона или исчезание в пустой      фон).
//  X8_FILLED_RIPPLES                                                                  // анимация ряби        на закрашенном фоне (появление из закрашенного фона или исчезание в закрашенный фон).
//  X8_EMPTY_DOWN                                                                      // анимация сверху-вниз на пустом      фоне (появление из пустого      фона или исчезание в пустой      фон).
//  X8_FILLED_DOWN                                                                     // анимация сверху-вниз на закрашенном фоне (появление из закрашенного фона или исчезание в закрашенный фон).
//  X8_EMPTY_TOP                                                                       // анимация снизу-вверх на пустом      фоне (появление из пустого      фона или исчезание в пустой      фон).
//  X8_FILLED_TOP                                                                      // анимация снизу-вверх на закрашенном фоне (появление из закрашенного фона или исчезание в закрашенный фон).