// Пример для одного светодиодного индикатора:                                         //
#include <Wire.h>                                                                      // Подключаем библиотеку Wire. Для работы с Arduino/Piranha, эту библиотеку можно не подключать.
#include <iarduino_Metro.h>                                                            // Подключаем библиотеку.
                                                                                       //
uint8_t sum;                                                                           // Объявляем переменную для хранения количества найденных модулей Metro.
                                                                                       //
void setup(){                                                                          //
//  Определяем все модули на шине I2C и сохраняем их количество в переменную sum:      //
    sum=iarduino_Metro_Start();                                                        // В качестве аргумента функции iarduino_Metro_Start() можно указать номер адресного вывода (если вывод не указан, то будет использован D12).
//  Теперь нам доступен массив Metro содержащий sum элементов для управления модулями. // Metro[0] управляет ближайшим к Arduino модулем, Metro[1] управляет следующим модулем и т.д до последнего модуля Metro[sum-1].
                                                                                       //
//  Проверяем наличие модулей Metro на шине I2C:                                       //
    while(sum==0){;}                                                                   // Если модули Metro не обнаружены, то входим в бесконечный цикл while, тогда цикл loop выполняться не будет.
    while(Metro[0].model!=MOD_8X8){;}                                                  // Если ближайший к Arduino модуль Metro не является светодиодным индикатором, то так же входим в бесконечный цикл while.
                                                                                       //
    delay(100);                                                                        // Синтаксис функции set( "строка", скорость [, время паузы] );
}                                                                                      // Скорость бегущей строки указывается от 1 до 255. Если указать 0, то бегущая строка не будет прокручиваться.
                                                                                       // Пауза между прокрутками бегущий строки указывается в мс от 100 до 25000 с шагом 100 мс. Если указать 0, или не указывать это значение, то бегущая строка прокрутится однократно и исчезнет.
void loop(){                                                                           //
//  Выводим на дисплей бегущую строку:                                                 //
    Metro[0].set("Hello world", 250, 500);                                             // Текст бегущей строки "Hello world", скорость прокрутки 250, пауза между прокрутками бегущий строки 500 мс.
    delay(12000);                                                                      // Ждём 10 секунд.
    Metro[0].off();                                                                    // Выключаем дисплей.
    delay(1000);                                                                       // Ждём 1 секунду.
                                                                                       //
    Metro[0].set("iArduino.ru", 250, 500);                                             // Текст бегущей строки "iArduino.ru", скорость прокрутки 250, пауза между прокрутками бегущий строки 500 мс.
    delay(12000);                                                                      // Ждём 10 секунд.
    Metro[0].off();                                                                    // Выключаем дисплей.
    delay(1000);                                                                       // Ждём 1 секунду.
}                                                                                      //
                                                                                       //
// Время требуемое на прокрутку строки можно приблизительно рассчитать по формуле:     //
// (256-скорость) * (количество символов-1) * 6 / 100 + 2 сек + пауза.                 // где 6 это ширина символа (5) и ширина межсимвольного интервала (1), а 2 сек. это время простоя на первом и последнем символе.
//                                                                                     //
// В строках "Hello world" и "iArduino.ru" по 11 символов, скорость=250, пауза=500 мс. //
// Значит на прокрутку строки уйдёт (256-250)*(11-1)*6/100+2+0,5 = 6,1 сек.            //
// Следовательно за 12 секунд ожидания строка успеет прокрутиться два раза.            //