// Пример для одной кнопоки:                                                              //
#include <Wire.h>                                                                         // Подключаем библиотеку Wire. Для работы с Arduino/Piranha, эту библиотеку можно не подключать.
#include <iarduino_Metro.h>                                                               // Подключаем библиотеку.
                                                                                          //
uint8_t sum;                                                                              // Объявляем переменную для хранения количества найденных модулей Metro.
                                                                                          //
void setup(){                                                                             //
//  Определяем все модули на шине I2C и сохраняем их количество в переменную sum:         //
    sum=iarduino_Metro_Start();                                                           // В качестве аргумента функции iarduino_Metro_Start() можно указать номер адресного вывода (если вывод не указан, то будет использован D12).
//  Теперь нам доступен массив Metro содержащий sum элементов для управления модулями.    // Metro[0] управляет ближайшим к Arduino модулем, Metro[1] управляет следующим модулем и т.д до последнего модуля Metro[sum-1].
                                                                                          //
//  Готовимся управлять светодиодом на плате Arduino:                                     //
    pinMode     (LED_BUILTIN, OUTPUT);                                                    // Конфигурируем вывод к которому подключён светодиод как выход.
    digitalWrite(LED_BUILTIN, LOW   );                                                    // Устанавливаем низкий логический уровень на выводе к которому подключён светодиод (выключаем светодиод).
                                                                                          //
//  Проверяем наличие модулей Metro на шине I2C:                                          //
    while(sum==0){;}                                                                      // Если модули Metro не обнаружены, то входим в бесконечный цикл while, тогда цикл loop выполняться не будет.
    while(Metro[0].model!=MOD_KEY){;}                                                     // Если ближайший к Arduino модуль Metro не является кнопкой, то так же входим в бесконечный цикл while.
}                                                                                         //
                                                                                          //
void loop(){                                                                              //
    if(Metro[0].read(KEY_PRESSED)==0){ digitalWrite(LED_BUILTIN, LOW ); }else             // Если кнопка не нажата, то выключаем светодиод на плате Arduino, иначе ...
    if(Metro[0].read(KEY_TIME)>=5000){ digitalWrite(LED_BUILTIN, HIGH); }                 // Если кнопка удерживается дольше 5 секунд, то включаем светодиод на плате Arduino.
}                                                                                         //